class UNet(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  encoder : __torch__.glow.models.segmentation.components.unet.Encoder
  decoder : __torch__.glow.models.segmentation.components.unet.Decoder
  head : __torch__.torch.nn.modules.conv.___torch_mangle_26.Conv3d
  def forward(self: __torch__.glow.models.segmentation.components.unet.UNet,
    x: Tensor) -> Tensor:
    encoder = self.encoder
    enc_ftrs = (encoder).forward(x, )
    decoder = self.decoder
    _0 = enc_ftrs[-1]
    _1 = torch.slice(torch.slice(enc_ftrs, None, -1), None, None, -1)
    out = (decoder).forward(_0, _1, )
    head = self.head
    return (head).forward(out, )
class Encoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  enc_blocks : __torch__.torch.nn.modules.container.ModuleList
  pool : __torch__.torch.nn.modules.pooling.MaxPool3d
  def forward(self: __torch__.glow.models.segmentation.components.unet.Encoder,
    x: Tensor) -> List[Tensor]:
    _2 = annotate(List[Tensor], [])
    enc_blocks = self.enc_blocks
    _0 = getattr(enc_blocks, "0")
    _1 = getattr(enc_blocks, "1")
    _20 = getattr(enc_blocks, "2")
    _3 = getattr(enc_blocks, "3")
    x0 = (_0).forward(x, )
    _4 = torch.append(_2, x0)
    pool = self.pool
    x1 = (pool).forward(x0, )
    x2 = (_1).forward(x1, )
    _5 = torch.append(_2, x2)
    pool0 = self.pool
    x3 = (pool0).forward(x2, )
    x4 = (_20).forward(x3, )
    _6 = torch.append(_2, x4)
    pool1 = self.pool
    x5 = (pool1).forward(x4, )
    x6 = (_3).forward(x5, )
    _7 = torch.append(_2, x6)
    pool2 = self.pool
    x7 = (pool2).forward(x6, )
    return _2
class Block(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv1 : __torch__.torch.nn.modules.conv.Conv3d
  bn1 : __torch__.torch.nn.modules.normalization.GroupNorm
  relu : __torch__.torch.nn.modules.activation.ReLU
  conv2 : __torch__.torch.nn.modules.conv.___torch_mangle_0.Conv3d
  bn2 : __torch__.torch.nn.modules.normalization.GroupNorm
  def forward(self: __torch__.glow.models.segmentation.components.unet.Block,
    x: Tensor) -> Tensor:
    relu = self.relu
    bn2 = self.bn2
    conv2 = self.conv2
    relu0 = self.relu
    bn1 = self.bn1
    conv1 = self.conv1
    _7 = (bn1).forward((conv1).forward(x, ), )
    _8 = (conv2).forward((relu0).forward(_7, ), )
    _9 = (relu).forward((bn2).forward(_8, ), )
    return _9
class Decoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  upconvs : __torch__.torch.nn.modules.container.___torch_mangle_18.ModuleList
  dec_blocks : __torch__.torch.nn.modules.container.___torch_mangle_25.ModuleList
  def forward(self: __torch__.glow.models.segmentation.components.unet.Decoder,
    x: Tensor,
    encoder_features: List[Tensor]) -> Tensor:
    _10 = __torch__.torch.nn.functional.___torch_mangle_35.interpolate
    upconvs = self.upconvs
    _0 = getattr(upconvs, "0")
    _1 = getattr(upconvs, "1")
    _2 = getattr(upconvs, "2")
    dec_blocks = self.dec_blocks
    _06 = getattr(dec_blocks, "0")
    enc_ftrs = encoder_features[0]
    x8 = (_0).forward(x, )
    _11 = torch.ne(torch.size(x8), torch.size(enc_ftrs))
    if _11:
      _12 = torch.slice(torch.size(enc_ftrs), 2)
      x10 = _10(x8, _12, None, "nearest", None, None, False, )
      x9 = x10
    else:
      x9 = x8
    x11 = torch.cat([x9, enc_ftrs], 1)
    x12 = (_06).forward(x11, )
    dec_blocks0 = self.dec_blocks
    _17 = getattr(dec_blocks0, "1")
    enc_ftrs0 = encoder_features[1]
    x13 = (_1).forward(x12, )
    _13 = torch.ne(torch.size(x13), torch.size(enc_ftrs0))
    if _13:
      _14 = torch.slice(torch.size(enc_ftrs0), 2)
      x15 = _10(x13, _14, None, "nearest", None, None, False, )
      x14 = x15
    else:
      x14 = x13
    x16 = torch.cat([x14, enc_ftrs0], 1)
    x17 = (_17).forward(x16, )
    dec_blocks1 = self.dec_blocks
    _28 = getattr(dec_blocks1, "2")
    enc_ftrs1 = encoder_features[2]
    x18 = (_2).forward(x17, )
    _15 = torch.ne(torch.size(x18), torch.size(enc_ftrs1))
    if _15:
      _16 = torch.slice(torch.size(enc_ftrs1), 2)
      x20 = _10(x18, _16, None, "nearest", None, None, False, )
      x19 = x20
    else:
      x19 = x18
    x21 = torch.cat([x19, enc_ftrs1], 1)
    return (_28).forward(x21, )
